<?php
/****************************************************************
* SMF TopicRating											*
* Subs-RateTopic.php												*
*****************************************************************/


if (!defined('SMF'))
	die('Hacking Attempt...');

function Rate()
{
	global $db_prefix, $user_info, $smcFunc;

	$rateOptions['member'] = $user_info['id'];
	$rateOptions['topic'] = !empty($_POST['topic']) ? (int) $_POST['topic'] : 0;
	$rateOptions['board'] = !empty($_POST['board']) ? (int) $_POST['board'] : 0;
	$rateOptions['rate'] = !empty($_POST['rate']) ? (int) $_POST['rate'] : 0;

	foreach($rateOptions as $option)
		if(empty($option))
			fatal_lang_error('rate_missing_info', false);

	if($rateOptions['rate'] > 5 || $rateOptions['rate'] < 1)
		fatal_lang_error('rate_not_in_range', false);

	$rateOptions['time'] = time();
	
	//Check if previous rate exists
	$data= $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}log_rt
		WHERE id_member = {int:id_member} AND id_topic = {int:id_topic}',
		array(
		 'id_member' => $rateOptions['member'],
		 'id_topic' => $rateOptions['topic'],
		)
	);
	$res = $smcFunc['db_fetch_row']($data);
	if ( $res[0] != 0 ) {
		//update the database
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}log_rt
			SET
				rate = {float:rate},
				time = {int:time}
			WHERE id_member = {int:id_member} AND id_topic = {int:id_topic}',
			array(
				'id_member' => $rateOptions['member'],
				'id_topic' => $rateOptions['topic'],
				'rate' => $rateOptions['rate'],
				'time' => $rateOptions['time'],
			)
		);
	}else{
		//store in database
		$smcFunc['db_insert']('insert',
			'{db_prefix}log_rt',
			array(
				'id_member' => 'int', 
				'id_topic' => 'int', 
				'rate' => 'float',
				'time' => 'text',
			),
			array(
				$rateOptions['member'], 
				$rateOptions['topic'], 
				$rateOptions['rate'], 
				$rateOptions['time'],
			),
			array()
		);
	}
	
	//Store average rate in SMF_MESSAGES
	$rating_values = getRatingAverage($rateOptions['topic']);
	$smcFunc['db_query']('', '
		UPDATE {db_prefix}messages
		SET
			rate = {float:rate}
		WHERE id_topic = {int:id_topic}',
		array(
			'id_topic' => $rateOptions['topic'],
			'rate' => (float)$rating_values[0],
		)
	);
	
	//redirection
	redirectexit('topic=' . $rateOptions['topic'] . '.0');
}

function getRatingAverage($topic_id = null)
{
	global $db_prefix, $smcFunc;

	$topic_id = (int) $topic_id;
	
	if(empty($topic_id))
		return 0;
	
	$data= $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}log_rt
		WHERE id_topic = {int:id_topic}',
		array(
		 'id_topic' => $topic_id,
		)
	);
	$res = $smcFunc['db_fetch_row']($data);
	if ( $res[0] != 0 ) {
		$data= $smcFunc['db_query']('', '
			SELECT rate
			FROM {db_prefix}log_rt
			WHERE id_topic = {int:id_topic}',
			array(
			 'id_topic' => $topic_id,
			)
		);
		while ($row = $smcFunc['db_fetch_row']($data)){
			$return[] = $row[0];
		}
	}

	if(!empty($return))
		$average = array_sum($return) / count($return);
	else
		return '';

	return array($average,count($return));
}

function getUserRating($topic_id = null)
{
	global $db_prefix, $user_info,  $smcFunc;
	
	$data= $smcFunc['db_query']('', '
		SELECT rate
		FROM {db_prefix}log_rt
		WHERE id_topic = {int:id_topic} AND id_member = {int:id_member}',
		array(
			'id_member' => $user_info['id'],
			'id_topic' => $topic_id,
		)
	);
	$row = $smcFunc['db_fetch_row']($data);
	$check = $row[0];

	if(empty($check))
		return 0;
	else
		return $check;
}

function getBoardRatingStatus($board = null)
{
	global $db_prefix, $smcFunc;
	$data= $smcFunc['db_query']('', '
			SELECT rateTopic_board_enable
			FROM {db_prefix}boards
		WHERE id_board = {int:id_board}',
		array(
		 'id_board' => $board,
		)
	);
	$row = $smcFunc['db_fetch_row']($data);
	return $row[0];
}

?>